import { Injectable, OnDestroy } from "@angular/core";
import { Subject } from "rxjs";

@Injectable()
export class Destroyed implements OnDestroy {
  protected readonly destroyed: Subject<void>;

  constructor() {
    this.destroyed = new Subject<void>();
    console.warn(
      "Will be deleted in next version, use takeUntilDestroyed from @angular/core/rxjs-interop instead"
    );
  }

  ngOnDestroy(): void {
    this.destroyed.next();
    this.destroyed.complete();
  }
}
