import { Injectable } from "@angular/core";
import {
  HttpRequest,
  HttpHandler,
  HttpEvent,
  HttpInterceptor,
} from "@angular/common/http";
import { finalize, Observable } from "rxjs";
import { LoadingService } from "src/app/services/loading.service";

@Injectable()
export class LoadingInterceptor implements HttpInterceptor {
  excludeUrl: string[] = [];
  constructor(private readonly loadingService: LoadingService) {}

  intercept(
    request: HttpRequest<unknown>,
    next: HttpHandler
  ): Observable<HttpEvent<unknown>> {
    if (!this.excludeUrl.includes(request.url)) {
      this.loadingService.show();
      return next.handle(request).pipe(
        finalize(() => {
          this.loadingService.hide();
        })
      );
    } else {
      return next.handle(request);
    }
  }
}
