import { Component, OnInit } from "@angular/core";
import { CommonModule } from "@angular/common";
import { LoadingService } from "src/app/services/loading.service";
import { Destroyed } from "../../injectables/destroyed.injectable";
import { takeUntil } from "rxjs";

@Component({
  selector: "app-loading",
  standalone: true,
  imports: [CommonModule],
  templateUrl: "./loading.component.html",
  styleUrls: ["./loading.component.scss"],
})
export class LoadingComponent extends Destroyed implements OnInit {
  public isLoading: boolean = false;
  constructor(private readonly loadingService: LoadingService) {
    super();
  }

  ngOnInit(): void {
    this.loadingService.loading
      .pipe(takeUntil(this.destroyed))
      .subscribe((val: boolean) => {
        this.isLoading = val;
      });
  }
}
